/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.43 from the
 * contents of Image.xs. Do not edit this file, edit Image.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "Image.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "ppport.h"

/******************************************************************************
 *          Copyright (c) 2006 Toutatis Internet Publishing Software 
 *          All rights reserved.                 http://toutatis.com
 *
 * This library is free software; you can redistribute it and/or modify it 
 * under the same terms as Perl itself. See the "Artistic License" in the Perl 
 * source code distribution for licensing terms.
 *
 ******************************************************************************
 * Author: Joost Diepenmaat / Zeekat Softwareontwikkeling - joost@zeekat.nl
 ******************************************************************************
 * WKB parsing code taken from mapserver, which has the following copyright
 * notification:
 ******************************************************************************
 * Copyright (c) 1996-2005 Regents of the University of Minnesota.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in 
 * all copies of this Software or works derived from this Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
 * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 ******************************************************************************
 */



#if !defined(_WIN32)
#include <netinet/in.h>
#endif
#include <sys/types.h>


#define MAX_POINTS_PER_LINE 20000

#ifndef LITTLE_ENDIAN
#define LITTLE_ENDIAN 1
#endif
#ifndef BIG_ENDIAN
#define BIG_ENDIAN 2
#endif

#ifndef WKBTYPE_GEOMETRY
#define WKBTYPE_GEOMETRY 0
#define WKBTYPE_POINT 1
#define WKBTYPE_LINESTRING 2
#define WKBTYPE_POLYGON 3
#define WKBTYPE_MULTIPOINT 4
#define WKBTYPE_MULTILINESTRING 5
#define WKBTYPE_MULTIPOLYGON 6
#define WKBTYPE_GEOMETRYCOLLECTION 7
#endif

#include <gd.h>

static int gBYTE_ORDER = 0;

static gdPoint points[MAX_POINTS_PER_LINE];

void Geo__GD__Image_end_memcpy(char order, void* dest, void* src, int num)
{
  u_int16_t* shorts=NULL;
  u_int32_t* longs;
  int order_test = 1;
  
  if (gBYTE_ORDER ==0) {
    if( ((char *) &order_test)[0] == 1 ) gBYTE_ORDER = LITTLE_ENDIAN;
    else gBYTE_ORDER = BIG_ENDIAN;
  }
  
  if (
      (gBYTE_ORDER == LITTLE_ENDIAN && order == 1) ||
      (gBYTE_ORDER == BIG_ENDIAN && order == 0) 		/* no change required */
      ){
  } else if ((gBYTE_ORDER == LITTLE_ENDIAN && order == 0)){	/* we're little endian but data is big endian */
  } else if ((gBYTE_ORDER == BIG_ENDIAN && order == 1)){	/* we're big endian but data is little endian */
    
    switch (num){
    case 2:
      shorts = (u_int16_t*) shorts;
      *shorts = htons(*shorts);
      break;
    case 4:			
      longs = (u_int32_t*) src;
      *longs = htonl(*longs);
      break;
    case 8:			
      longs = (u_int32_t*) src;
      *longs = htonl(*longs);
      longs ++;
      *longs = htonl(*longs);
      break;
    }
    
  }
  memcpy(dest, src, num);
}

int Geo__GD__Image_add_point(gdImagePtr image, char *wkb, int color, double offsetx, double offsety, double ratiox, double ratioy)
{
  char byteorder = 0;
  float x;
  float y;

  byteorder = wkb[0];
  
  Geo__GD__Image_end_memcpy(byteorder,  &x , &wkb[5  ], 8);
  Geo__GD__Image_end_memcpy(byteorder,  &y , &wkb[5+8], 8);
  gdImageSetPixel(image, (int) ( ratiox * ( x - offsetx ) ), (int) ( ratioy * ( y - offsety ) ), color);
  return 0;
}


int Geo__GD__Image_add_linestring(gdImagePtr image, char *wkb, int color, double offsetx, double offsety, double ratiox, double ratioy)
{
  int	u;
  char byteorder = 0;
  byteorder = wkb[0];
  int numpoints;
  int x1,y1,x2,y2;

  Geo__GD__Image_end_memcpy(byteorder, &numpoints, &wkb[5],4); /* num points */

  if (numpoints > MAX_POINTS_PER_LINE) croak("Too many points. Increase MAX_POINTS_PER_LINE");
  if (numpoints < 2) {
    croak("Can't handle a linestring with less than 2 points");
  }
  else if (numpoints == 2) {
    Geo__GD__Image_end_memcpy(byteorder,  &x1 , &wkb[9], 8);
    Geo__GD__Image_end_memcpy(byteorder,  &y1 , &wkb[17], 8);    
    Geo__GD__Image_end_memcpy(byteorder,  &x2 , &wkb[25], 8);
    Geo__GD__Image_end_memcpy(byteorder,  &y2 , &wkb[33], 8);    
    gdImageLine(image, 
		(int) ( ratiox * ( x1 - offsetx ) ), 
		(int) ( ratioy * ( y1 - offsety ) ),
		(int) ( ratiox * ( x2 - offsetx ) ), 
		(int) ( ratioy * ( y2 - offsety ) ),
		color);
  }
  else {

    for(u=0;u<numpoints ; u++)
      {
	Geo__GD__Image_end_memcpy(byteorder, &x1, &wkb[9 + (16 * u)], 8);
	Geo__GD__Image_end_memcpy(byteorder, &y1, &wkb[9 + (16 * u)+8], 8);
	points[u].x = (int) ( ratiox * ( x1 - offsetx ) );
	points[u].y = (int) ( ratioy * ( y1 - offsety ) );
      }
    gdImageOpenPolygon(image, points, numpoints, color);
  }
  return 9 + (16 * numpoints);
}

int Geo__GD__Image_add_multilinestring( gdImagePtr image, char *wkb,int color, double offsetx, double offsety, double ratiox, double ratioy)
{
  int offset =0;
  int u;
  int nstrings;
  char byteorder = 0;

  byteorder = wkb[0];
  
  Geo__GD__Image_end_memcpy(byteorder, &nstrings, &wkb[offset+5],4); /* num linstrings */
  for(u=0;u<nstrings ; u++)
    {
      offset += Geo__GD__Image_add_linestring( image, &wkb[offset+9], color, offsetx, offsety, ratiox, ratioy );
    }
  return offset;
}

int Geo__GD__Image_add_polygon(gdImagePtr image, char *wkb, int color, double offsetx, double offsety, double ratiox, double ratioy) {
  int offset =0,pt_offset;
  int u,v;
  int type,nrings,npoints;
  char byteorder = 0;
  double x,y;
  
  byteorder = wkb[0];

  Geo__GD__Image_end_memcpy(byteorder, &nrings, &wkb[offset+5],4); /* num rings */
  /* add a line for each polygon ring */
  pt_offset = 0;
  offset += 9; /* now points at 1st linear ring */
  for (u=0;u<nrings;u++)	/* for each ring, make a line */
    {
      Geo__GD__Image_end_memcpy(byteorder, &npoints, &wkb[offset],4); /* num points */

      if (npoints > MAX_POINTS_PER_LINE) croak("Too many points. Increase MAX_POINTS_PER_LINE");

      for(v=0;v<npoints;v++)
	{
	  Geo__GD__Image_end_memcpy(byteorder,  &x , &wkb[offset+4 + (16 * v)], 8);
	  Geo__GD__Image_end_memcpy(byteorder,  &y , &wkb[offset+4 + (16 * v)+8], 8);
	  points[v].x = (int) ( ratiox * ( x - offsetx ) );
	  points[v].y = (int) ( ratioy * ( y - offsety ) );
	  /*	  printf("%f x %f -> %d x %d ( %f  x %f )\n",x,y,points[v].x, points[v].y,  ratiox * ( x - offsetx ), ratioy * ( y - offsety )); */
	}
      /* make offset point to next linear ring */
      gdImageFilledPolygon(image, points, npoints, color);
      offset += 4+ (16)*npoints;
    }
  return offset;
}


int Geo__GD__Image_add_multipolygon(gdImagePtr image, char *wkb, int color, double offsetx, double offsety, double ratiox, double ratioy)  {
  int offset =0;
  int w;
  char byteorder = 0;
  int npolygons;
  byteorder = wkb[0];
  
  Geo__GD__Image_end_memcpy(byteorder, &npolygons, &wkb[offset+5],4); /* num polygons */
  offset+=9;
  for (w=0; w< npolygons; w++) {
    offset += Geo__GD__Image_add_polygon(image, &wkb[offset], color, offsetx, offsety, ratiox, ratioy );
  }
  return offset;
}



/* add a WKB blob to an image */

int	Geo__GD__Image_draw_wkb(gdImagePtr image, char *wkb, int color, double offsetx, double offsety, double ratiox, double ratioy)
{
  
  int offset =0;
  int	type,t,ngeoms;
  char byteorder = 0;
  
  byteorder = wkb[0];
  
  Geo__GD__Image_end_memcpy(byteorder,  &type, &wkb[1], 4);
  switch(type) {
  case WKBTYPE_POLYGON:
    return Geo__GD__Image_add_polygon(image, wkb, color, offsetx, offsety, ratiox, ratioy);
    break;
  case WKBTYPE_MULTIPOLYGON:
    return Geo__GD__Image_add_multipolygon(image, wkb, color, offsetx, offsety, ratiox, ratioy);
    break;
  case WKBTYPE_GEOMETRYCOLLECTION:
    Geo__GD__Image_end_memcpy(byteorder,  &ngeoms, &wkb[5], 4);
    offset = 9;  /* were the first geometry is */
    for (t=0; t<ngeoms; t++)
      {
	offset+= Geo__GD__Image_draw_wkb( image, &wkb[offset], color, offsetx, offsety, ratiox, ratioy);
      }
    return offset;
    break;
  case WKBTYPE_LINESTRING:
    return Geo__GD__Image_add_linestring(image, wkb, color, offsetx, offsety, ratiox, ratioy);
    break;
  case WKBTYPE_MULTILINESTRING:
    return Geo__GD__Image_add_multilinestring(image, wkb, color, offsetx, offsety, ratiox, ratioy);
    break;
  case WKBTYPE_POINT:
    return Geo__GD__Image_add_point(image, wkb, color, offsetx, offsety, ratiox, ratioy);
    break;
  }
  croak("Unhandled WKB (sub)type %d",type);
}


#line 292 "Image.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 436 "Image.c"

XS_EUPXS(XS_Geo__GD__Image_draw_wkb); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Geo__GD__Image_draw_wkb)
{
    dVAR; dXSARGS;
    if (items != 7)
       croak_xs_usage(cv,  "image, wkb, color, offsetx, offsety, ratiox, ratioy");
    {
	gdImagePtr	image;
	char *	wkb = (char *)SvPV_nolen(ST(1))
;
	int	color = (int)SvIV(ST(2))
;
	double	offsetx = (double)SvNV(ST(3))
;
	double	offsety = (double)SvNV(ST(4))
;
	double	ratiox = (double)SvNV(ST(5))
;
	double	ratioy = (double)SvNV(ST(6))
;
	int	RETVAL;
	dXSTARG;

    if (sv_derived_from(ST(0), "GD::Image")) {
	IV tmp = SvIV((SV*)SvRV(ST(0)));
        image = (gdImagePtr) tmp;
    }
    else
	croak("image is not of type GD::Image")
;

	RETVAL = Geo__GD__Image_draw_wkb(image, wkb, color, offsetx, offsety, ratiox, ratioy);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Geo__GD__Image_alpha); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Geo__GD__Image_alpha)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "image, c");
    {
	gdImagePtr	image;
	int	c = (int)SvIV(ST(1))
;
	int	RETVAL;
	dXSTARG;

    if (sv_derived_from(ST(0), "GD::Image")) {
	IV tmp = SvIV((SV*)SvRV(ST(0)));
        image = (gdImagePtr) tmp;
    }
    else
	croak("image is not of type GD::Image")
;
#line 300 "Image.xs"
    RETVAL = gdImageAlpha(image,c);
#line 498 "Image.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Geo__GD__Image); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Geo__GD__Image)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Geo::GD::Image::draw_wkb", XS_Geo__GD__Image_draw_wkb);
        newXS_deffile("Geo::GD::Image::alpha", XS_Geo__GD__Image_alpha);
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

